
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8L
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 200 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _TimerForQuantizator=R5
	.DEF _TimerForAnalysisSignal=R4
	.DEF _SystemRPstatus=R7
	.DEF _CursorMemBufferRecPlay=R8
	.DEF _CounterLengRec=R10
	.DEF _CounterLengRecShellInterval=R12
	.DEF _CounterSboiSDcard=R6

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0xD0:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x08
	.DW  0x04
	.DW  _0xD0*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x128)
	LDI  R29,HIGH(0x128)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x128

	.CSEG
;/*****************************************************
;Chip type               : ATmega8L
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;
;if (PINB.7 ==1){ // 
;PORTD.2=1; //   1
;PORTD.3=1; //   2 (     :  =  )
;PORTD.5=1; // 
;
;OCR1AH=0;
;OCR1AL  PWM 256  
;
;ADC6 =   0 ... V+
;
;SD Card = MIN 2Gb
;1 sector = (256/(8000000/256/3)) sec
;61 sector = 1 sec
;
;
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;#include "mmc_if_rec_play.c"
;
;/* ***********************************************************************
;**
;**  Copyright (C) 2006  Jesper Hansen <jesper@redegg.net>
;**
;**
;**  Interface functions for MMC/SD cards
;**
;**  File mmc_if.h
;**
;**  Hacked by Michael Spiceland at http://tinkerish.com to support
;**  writing as well.
;**
;*************************************************************************
;**
;**  This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**  This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**  You should have received a copy of the GNU General Public License
;**  along with this program; if not, write to the Free Software Foundation,
;**  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;**
;*************************************************************************/
;
;/** \file mmc_if.c
;        Simple MMC/SD-card functionality
;*/
;
;
;#include <stdio.h>
;#include "mmc_if.h"
;
;
;/** Hardware SPI I/O.
;        \param byte Data to send over SPI bus
;        \return Received data from SPI bus
;*/
;uint8_t spi_byte(uint8_t byte)
; 0000 001E {

	.CSEG
_spi_byte:
;        SPDR = byte;
;	byte -> Y+0
	LD   R30,Y
	OUT  0xF,R30
;        while(!(SPSR & (1<<SPIF)))
_0x3:
	SBIS 0xE,7
;        {}
	RJMP _0x3
;        return SPDR;
	IN   R30,0xF
	ADIW R28,1
	RET
;}
;
;
;
;/** Send a command to the MMC/SD card.
;        \param command  Command to send
;        \param px       Command parameter 1
;        \param py       Command parameter 2
;*/
;void mmc_send_command(uint8_t command, uint16_t px, uint16_t py)
;{
_mmc_send_command:
;        register union u16convert r;
;
;        MMC_CS_PORT &= ~(1 << MMC_CS);  // enable CS
	SBIW R28,2
;	command -> Y+6
;	px -> Y+4
;	py -> Y+2
;	r -> Y+0
	CBI  0x18,2
;
;        spi_byte(0xff);                 // dummy byte
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
;
;        spi_byte(command | 0x40);
	LDD  R30,Y+6
	ORI  R30,0x40
	ST   -Y,R30
	RCALL _spi_byte
;
;        r.value = px;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   Y,R30
	STD  Y+1,R31
;        spi_byte(r.bytes.high); // high byte of param x
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _spi_byte
;        spi_byte(r.bytes.low);  // low byte of param x
	LD   R30,Y
	ST   -Y,R30
	RCALL _spi_byte
;
;        r.value = py;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   Y,R30
	STD  Y+1,R31
;        spi_byte(r.bytes.high); // high byte of param y
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _spi_byte
;        spi_byte(r.bytes.low);  // low byte of param y
	LD   R30,Y
	ST   -Y,R30
	RCALL _spi_byte
;
;        spi_byte(0x95);                 // correct CRC for first command in SPI
	LDI  R30,LOW(149)
	ST   -Y,R30
	RCALL _spi_byte
;                                                        // after that CRC is ignored, so no problem with
;                                                        // always sending 0x95
;        spi_byte(0xff);                 // ignore return byte
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
;}
	ADIW R28,7
	RET
;
;
;/** Get Token.
;        Wait for and return a non-ff token from the MMC/SD card
;        \return The received token or 0xFF if timeout
;*/
;uint8_t mmc_get(void)
;{
_mmc_get:
;        uint16_t i = 0xffff;
;        uint8_t b = 0xff;
;
;        while ((b == 0xff) && (--i))
	RCALL __SAVELOCR4
;	i -> R16,R17
;	b -> R19
	__GETWRN 16,17,-1
	LDI  R19,255
_0x6:
	CPI  R19,255
	BRNE _0x9
	__SUBWRN 16,17,1
	BRNE _0xA
_0x9:
	RJMP _0x8
_0xA:
;        {
;                b = spi_byte(0xff);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	MOV  R19,R30
;        }
	RJMP _0x6
_0x8:
;        return b;
	MOV  R30,R19
	RCALL __LOADLOCR4
	RJMP _0x2060006
;
;}
;
;/** Get Datatoken.
;        Wait for and return a data token from the MMC/SD card
;        \return The received token or 0xFF if timeout
;*/
;uint8_t mmc_datatoken(void)
;{
_mmc_datatoken:
;        uint16_t i = 0xffff;
;        uint8_t b = 0xff;
;
;        while ((b != 0xfe) && (--i))
	RCALL __SAVELOCR4
;	i -> R16,R17
;	b -> R19
	__GETWRN 16,17,-1
	LDI  R19,255
_0xB:
	CPI  R19,254
	BREQ _0xE
	__SUBWRN 16,17,1
	BRNE _0xF
_0xE:
	RJMP _0xD
_0xF:
;        {
;                b = spi_byte(0xff);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	MOV  R19,R30
;        }
	RJMP _0xB
_0xD:
;        return b;
	MOV  R30,R19
	RCALL __LOADLOCR4
	RJMP _0x2060006
;}
;
;
;/** Finish Clocking and Release card.
;        Send 10 clocks to the MMC/SD card
;        and release the CS line
;*/
;void mmc_clock_and_release(void)
;{
_mmc_clock_and_release:
;        uint8_t i;
;
;        // SD cards require at least 8 final clocks
;        for(i=0;i<10;i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x11:
	CPI  R17,10
	BRSH _0x12
;                spi_byte(0xff);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	SUBI R17,-1
	RJMP _0x11
_0x12:
	SBI  0x18,2
;}
	RJMP _0x2060002
;
;
;
;/** Read MMC/SD sector.
;        Read a single 512 byte sector from the MMC/SD card
;        \param lba      Logical sectornumber to read
;        \param buffer   Pointer to buffer for received data
;        \return 0 on success, -1 on error
;*/
;int mmc_readsector_start256(uint32_t lba, uint8_t *buffer)
;{
_mmc_readsector_start256:
;        uint16_t i;
;
;
;        // send read command and logical sector address
;        mmc_send_command(17,(lba>>7) & 0xffff, (lba<<9) & 0xffff);
	RCALL __SAVELOCR2
;	lba -> Y+4
;	*buffer -> Y+2
;	i -> R16,R17
	LDI  R30,LOW(17)
	ST   -Y,R30
	__GETD2S 5
	LDI  R30,LOW(7)
	RCALL __LSRD12
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDI  R30,LOW(9)
	RCALL __LSLW12
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_send_command
;
;        if (mmc_datatoken() != 0xfe)    // if no valid token
	RCALL _mmc_datatoken
	CPI  R30,LOW(0xFE)
	BREQ _0x13
;        {
;                mmc_clock_and_release();        // cleanup and
	RCALL _mmc_clock_and_release
;                //for (i=0;i<512;i++)                           // we don't want a false impression that everything was fine.
;                //      *buffer++ = 0x00;
;                return -1;                                      // return error code
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2060003
;        }
;
;        for (i=0;i<256;i++){                             // read sector data
_0x13:
	__GETWRN 16,17,0
_0x15:
	__CPWRN 16,17,256
	BRSH _0x16
;        *buffer++ = spi_byte(0xff);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	SBIW R30,1
	PUSH R31
	PUSH R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	POP  R26
	POP  R27
	ST   X,R30
;}
	__ADDWRN 16,17,1
	RJMP _0x15
_0x16:
;
;        return 0;                                               // return success
	RJMP _0x2060004
;}
;
;
;int mmc_readsector_next256(uint8_t *buffer)
;{
_mmc_readsector_next256:
;        uint16_t i;
;
;
;        for (i=0;i<256;i++){                             // read sector data
	RCALL __SAVELOCR2
;	*buffer -> Y+2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x18:
	__CPWRN 16,17,256
	BRSH _0x19
;        *buffer++ = spi_byte(0xff);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	SBIW R30,1
	PUSH R31
	PUSH R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	POP  R26
	POP  R27
	ST   X,R30
;}
	__ADDWRN 16,17,1
	RJMP _0x18
_0x19:
;
;        spi_byte(0xff);                                 // ignore dummy checksum
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
;        spi_byte(0xff);                                 // ignore dummy checksum
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
;
;        return 0;                                               // return success
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL __LOADLOCR2
_0x2060006:
	ADIW R28,4
	RET
;}
;
;/************************** MMC get response **************************************/
;/**** Repeatedly reads the MMC until we get the response we want or timeout ****/
;/* this function taken from the PIC CCS example */
;int mmc_response(unsigned char response)
;{
_mmc_response:
;        unsigned long count = 0xFFFF;           // 16bit repeat, it may be possible to shrink this to 8 bit but there is not much point
;
;        while(spi_byte(0xFF) != response && --count > 0);
	SBIW R28,4
	LDI  R30,LOW(255)
	ST   Y,R30
	STD  Y+1,R30
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+3,R30
;	response -> Y+4
;	count -> Y+0
_0x1A:
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	MOV  R26,R30
	LDD  R30,Y+4
	CP   R30,R26
	BREQ _0x1D
	RCALL __GETD1S0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	RCALL __PUTD1S0
	MOVW R26,R30
	MOVW R24,R22
	RCALL __CPD02
	BRLO _0x1E
_0x1D:
	RJMP _0x1C
_0x1E:
	RJMP _0x1A
_0x1C:
;
;        if(count==0) return 1;                  // loop was exited due to timeout
	RCALL __GETD1S0
	RCALL __CPD10
	BRNE _0x1F
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x2060005
;        else return 0;                          // loop was exited before timeout
_0x1F:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;}
_0x2060005:
	ADIW R28,5
	RET
;
;
;/** Write MMC/SD sector.
;        Write a single 512 byte sector from the MMC/SD card
;        \param lba      Logical sectornumber to write
;        \param buffer   Pointer to buffer to write from
;        \return 0 on success, -1 on error
;*/
;int mmc_writesector(uint32_t lba, uint8_t *buffer)
;{
_mmc_writesector:
;        uint16_t i;
;
;        // send read command and logical sector address
;        mmc_send_command(24,(lba>>7) & 0xffff, (lba<<9) & 0xffff);
	RCALL __SAVELOCR2
;	lba -> Y+4
;	*buffer -> Y+2
;	i -> R16,R17
	LDI  R30,LOW(24)
	ST   -Y,R30
	__GETD2S 5
	LDI  R30,LOW(7)
	RCALL __LSRD12
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDI  R30,LOW(9)
	RCALL __LSLW12
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_send_command
;
;        // need wait for resonse here
;        if((mmc_response(0x00))==1)
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _mmc_response
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x21
;        {
;                mmc_clock_and_release();        // cleanup and
	RCALL _mmc_clock_and_release
;                return -1;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2060003
;        }
;
;        // need to send token here
;        spi_byte(0xfe);                                 // send data token /* based on PIC code example */
_0x21:
	LDI  R30,LOW(254)
	ST   -Y,R30
	RCALL _spi_byte
;
;        for (i=0;i<512;i++){                             // write sector data
	__GETWRN 16,17,0
_0x23:
	__CPWRN 16,17,512
	BRSH _0x24
;                spi_byte(*buffer++);
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X+
	STD  Y+2,R26
	STD  Y+2+1,R27
	ST   -Y,R30
	RCALL _spi_byte
;}
	__ADDWRN 16,17,1
	RJMP _0x23
_0x24:
;
;
;        spi_byte(0xff);                                 // ignore dummy checksum
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
;        spi_byte(0xff);                                 // ignore dummy checksum
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
;
;        // do we check the status here?
;        if((spi_byte(0xFF)&0x0F)!=0x05) return -1;
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	ANDI R30,LOW(0xF)
	CPI  R30,LOW(0x5)
	BREQ _0x25
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2060003
;
;/*
;,    
;   .
;     ,
;       push/pop  .
;
;        i = 0xffff;                                             // max timeout
;        while(!spi_byte(0xFF) && (--i)){;} // wait until we are not busy
;
;         mmc_clock_and_release();                // cleanup
;*/
;
;        return 0;                                               // return success
_0x25:
_0x2060004:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x2060003:
	RCALL __LOADLOCR2
	ADIW R28,8
	RET
;}
;
;
;/** Init MMC/SD card.
;        Initialize I/O ports for the MMC/SD interface and
;        send init commands to the MMC/SD card
;        \return 0 on success, other values on error
;*/
;uint8_t mmc_init(void)
;{
_mmc_init:
;        int i;
;
;
;        // setup I/O ports
;
;        SPI_PORT &= ~((1 << MMC_SCK) | (1 << MMC_MOSI));        // low bits
	RCALL __SAVELOCR2
;	i -> R16,R17
	IN   R30,0x18
	ANDI R30,LOW(0xD7)
	OUT  0x18,R30
;        SPI_PORT |= (1 << MMC_MISO);                                            // high bits
	SBI  0x18,4
;        SPI_DDR  |= (1<<MMC_SCK) | (1<<MMC_MOSI);                       // direction
	IN   R30,0x17
	ORI  R30,LOW(0x28)
	OUT  0x17,R30
;
;
;        MMC_CS_PORT |= (1 << MMC_CS);   // Initial level is high
	SBI  0x18,2
;        MMC_CS_DIR  |= (1 << MMC_CS);   // Direction is output
	SBI  0x17,2
;
;
;        // also need to set SS as output
;#if defined(__AVR_ATmega8__)
;        // is already set as CS, but we set it again to accomodate for other boards
;        SPI_DDR |= (1<<2);
;#else
;        SPI_DDR |= (1<<0);                      // assume it's bit0 (mega128, portB and others)
	SBI  0x17,0
;#endif
;
;        SPCR = (1<<MSTR)|(1<<SPE);      // enable SPI interface
	LDI  R30,LOW(80)
	OUT  0xD,R30
;        SPSR = 1;                                       // set double speed
	LDI  R30,LOW(1)
	OUT  0xE,R30
;
;        for(i=0;i<10;i++)                       // send 80 clocks while card power stabilizes
	__GETWRN 16,17,0
_0x27:
	__CPWRN 16,17,10
	BRGE _0x28
;                spi_byte(0xff);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	__ADDWRN 16,17,1
	RJMP _0x27
_0x28:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_send_command
;
;        if (mmc_get() != 1)                     // if no valid response code
	RCALL _mmc_get
	CPI  R30,LOW(0x1)
	BREQ _0x29
;        {
;           mmc_clock_and_release();
	RCALL _mmc_clock_and_release
;           return 1;                            // card cannot be detected
	LDI  R30,LOW(1)
	RJMP _0x2060001
;        }
;
;        //
;        // send CMD1 until we get a 0 back, indicating card is done initializing
;        //
;        i = 0xffff;                                             // max timeout
_0x29:
	__GETWRN 16,17,-1
;        while ((spi_byte(0xff) != 0) && (--i))  // wait for it
_0x2A:
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	CPI  R30,0
	BREQ _0x2D
	__SUBWRN 16,17,1
	BRNE _0x2E
_0x2D:
	RJMP _0x2C
_0x2E:
;        {
;             mmc_send_command(1,0,0);   // send CMD1 - activate card init
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_send_command
;        }
	RJMP _0x2A
_0x2C:
;
;    mmc_clock_and_release();            // clean up
	RCALL _mmc_clock_and_release
;
;        if (i == 0)                                             // if we timed out above
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x2F
;           return 2;                                    // return failure code
	LDI  R30,LOW(2)
	RJMP _0x2060001
;
;        return 0;
_0x2F:
	LDI  R30,LOW(0)
	RJMP _0x2060001
;}
;
;
;
;#define ADC_VREF_TYPE 0x60
;
;
;
;// 0 ... 1933593 sector (990 Mb rec/play area)
;#define MAXIMAL_SECTOR_NUMBER  1933593
;
;// if F=14.4M
;#define F_TIMER_DIV_CONST                       4
;// 27.46 sector = 1 sec
;//      (in sector)
;// 0.6 sec
;#define MINIMAL_REC_SECTOR_LEN_FOR_PLAY         16
;//    (in sector)
;// 32 sec
;#define MAXIMAL_REC_SECTOR_LEN                  878
;//         (in 1/335 sec)
;// 1 sec
;//  CB 250
;//  PMR/LPD 124
;#define SHELLED_INTERVAL_REC_PAST_SQL_CLOSE     335
;//         (  SHELLED_INTERVAL_REC_PAST_SQL_CLOSE)
;#define PLAY_SECTOR_AFTER_SQL_CLOSE             2
;//    PTT   (in 1/335 sec)
;// 0.4 sec
;#define DELAY_BETWEEN_PTT_AND_PLAYBACK          135
;//         PTT (in 1/335 sec)
;// 0.3 sec
;#define DELAY_PTT_ON_AFTER_ALL_PLAY             100
;
;
;
;//     " ",  1  1      " "
;#define SQL_OPEN_LOG_SIGNAL                     0
;
;
;unsigned char TimerForQuantizator=0; // 8000000/256/3 = 10417 
;unsigned char TimerForAnalysisSignal=0; // 8000000/256/3/42 = 248 
;
;unsigned char SystemRPstatus; // 0=  ; 1=; 2= ; 3=    ; 4= ; 5= ,    ,  ; 6=; 7= ,; 8=    PTT  ,  ; 9=   SD 
;unsigned char MemBuffer[612];
;bit FlagMemBufferNeedSendToSDbuffer=0;
;bit FlagWaitWriteSDbufferToFlash=0;
;bit FlagBufferToInCard=0;
;bit FlagBufferToRecPlay=0;
;bit FlagReadBufferInCard=0;
;bit FlagReadBufferInCardOk=0;
;bit FlagNeedReadNextData=0;
;
;
;unsigned int CursorMemBufferRecPlay; //      
;
;unsigned long int CursorSDsectorToWrite;
;unsigned long int CursorSDsectorToRead;
;unsigned int CounterLengRec=0;
;unsigned int CounterLengRecShellInterval;
;unsigned int CounterShellInterval;
;unsigned char CounterSboiSDcard;
;
;unsigned char CounterSQLopen=0;
;unsigned char CounterSQLclose=0;
;bit FlagSQLopen=0;
;unsigned int CounterPTTonAndPause;
;
;
;//     ADC     RAM   ,    ,      
;void QuantizatorREC(){
; 0000 0062 void QuantizatorREC(){
_QuantizatorREC:
; 0000 0063 unsigned char TempUchar0;
; 0000 0064 if (CursorMemBufferRecPlay <612){
	ST   -Y,R17
;	TempUchar0 -> R17
	LDI  R30,LOW(612)
	LDI  R31,HIGH(612)
	CP   R8,R30
	CPC  R9,R31
	BRSH _0x30
; 0000 0065 TempUchar0=ADCL;
	IN   R17,4
; 0000 0066 TempUchar0=ADCH;
	IN   R17,5
; 0000 0067 MemBuffer[CursorMemBufferRecPlay]=TempUchar0;
	MOVW R30,R8
	SUBI R30,LOW(-_MemBuffer)
	SBCI R31,HIGH(-_MemBuffer)
	ST   Z,R17
; 0000 0068 CursorMemBufferRecPlay=CursorMemBufferRecPlay+1;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
; 0000 0069 if (CursorMemBufferRecPlay ==512){FlagMemBufferNeedSendToSDbuffer=1;} //      "    RAM   SD "
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R30,R8
	CPC  R31,R9
	BRNE _0x31
	SET
	BLD  R2,0
; 0000 006A }
_0x31:
; 0000 006B } // void QuantizatorREC()
_0x30:
_0x2060002:
	LD   R17,Y+
	RET
;
;
;
;//      RAM    SD 
;void WriteDataToFlashBuffer(){
; 0000 0070 void WriteDataToFlashBuffer(){
_WriteDataToFlashBuffer:
; 0000 0071 unsigned int TempUInt0;
; 0000 0072 FlagMemBufferNeedSendToSDbuffer=0;
	RCALL __SAVELOCR2
;	TempUInt0 -> R16,R17
	CLT
	BLD  R2,0
; 0000 0073 if (CursorSDsectorToWrite > MAXIMAL_SECTOR_NUMBER){CursorSDsectorToWrite=0;}
	LDS  R26,_CursorSDsectorToWrite
	LDS  R27,_CursorSDsectorToWrite+1
	LDS  R24,_CursorSDsectorToWrite+2
	LDS  R25,_CursorSDsectorToWrite+3
	__CPD2N 0x1D811A
	BRLO _0x32
	LDI  R30,LOW(0)
	STS  _CursorSDsectorToWrite,R30
	STS  _CursorSDsectorToWrite+1,R30
	STS  _CursorSDsectorToWrite+2,R30
	STS  _CursorSDsectorToWrite+3,R30
; 0000 0074 if (mmc_writesector(CursorSDsectorToWrite, MemBuffer)){
_0x32:
	LDS  R30,_CursorSDsectorToWrite
	LDS  R31,_CursorSDsectorToWrite+1
	LDS  R22,_CursorSDsectorToWrite+2
	LDS  R23,_CursorSDsectorToWrite+3
	RCALL __PUTPARD1
	LDI  R30,LOW(_MemBuffer)
	LDI  R31,HIGH(_MemBuffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_writesector
	SBIW R30,0
	BREQ _0x33
; 0000 0075 PORTD.2=0; //  
	CBI  0x12,2
; 0000 0076 PORTD.3=0; //  
	CBI  0x12,3
; 0000 0077 if (CounterSboiSDcard <255){CounterSboiSDcard=CounterSboiSDcard+1;}
	LDI  R30,LOW(255)
	CP   R6,R30
	BRSH _0x38
	INC  R6
; 0000 0078 return;
_0x38:
	RJMP _0x2060001
; 0000 0079 }
; 0000 007A //  
; 0000 007B #asm("cli")
_0x33:
	cli
; 0000 007C if (CursorMemBufferRecPlay >512){ //    ?          "mmc_writesector(CursorSDsectorToWrite, MemBuffer)"   4,5   50-60    Fdsc=12khz
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CP   R30,R8
	CPC  R31,R9
	BRSH _0x39
; 0000 007D for (TempUInt0=512; TempUInt0<CursorMemBufferRecPlay; TempUInt0=TempUInt0+1){MemBuffer[(TempUInt0-512)]=MemBuffer[TempUInt0];} // ,     ,      RAM 
	__GETWRN 16,17,512
_0x3B:
	__CPWRR 16,17,8,9
	BRSH _0x3C
	MOVW R30,R16
	SUBI R30,LOW(512)
	SBCI R31,HIGH(512)
	SUBI R30,LOW(-_MemBuffer)
	SBCI R31,HIGH(-_MemBuffer)
	MOVW R0,R30
	LDI  R26,LOW(_MemBuffer)
	LDI  R27,HIGH(_MemBuffer)
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	__ADDWRN 16,17,1
	RJMP _0x3B
_0x3C:
; 0000 007E CursorMemBufferRecPlay=TempUInt0-511; // -512 + 1
	MOVW R30,R16
	SUBI R30,LOW(511)
	SBCI R31,HIGH(511)
	MOVW R8,R30
; 0000 007F }else{CursorMemBufferRecPlay=0;}
	RJMP _0x3D
_0x39:
	CLR  R8
	CLR  R9
_0x3D:
; 0000 0080 //  
; 0000 0081 #asm("sei")
	sei
; 0000 0082 CounterSboiSDcard=0;
	CLR  R6
; 0000 0083 CounterLengRec=CounterLengRec+1;
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
; 0000 0084 CursorSDsectorToWrite=CursorSDsectorToWrite+1;
	LDS  R30,_CursorSDsectorToWrite
	LDS  R31,_CursorSDsectorToWrite+1
	LDS  R22,_CursorSDsectorToWrite+2
	LDS  R23,_CursorSDsectorToWrite+3
	__ADDD1N 1
	STS  _CursorSDsectorToWrite,R30
	STS  _CursorSDsectorToWrite+1,R31
	STS  _CursorSDsectorToWrite+2,R22
	STS  _CursorSDsectorToWrite+3,R23
; 0000 0085 FlagWaitWriteSDbufferToFlash=1;
	SET
	BLD  R2,1
; 0000 0086 } // void WriteDataToFlashBuffer()
	RJMP _0x2060001
;
;
;
;
;
;
;
;
;
;
;
;//          PWM
;void QuantizatorPLAY(){
; 0000 0093 void QuantizatorPLAY(){
_QuantizatorPLAY:
; 0000 0094 if (FlagBufferToRecPlay ==0){OCR1AL=MemBuffer[CursorMemBufferRecPlay];}else{OCR1AL=MemBuffer[CursorMemBufferRecPlay+256];}
	SBRC R2,3
	RJMP _0x3E
	LDI  R26,LOW(_MemBuffer)
	LDI  R27,HIGH(_MemBuffer)
	ADD  R26,R8
	ADC  R27,R9
	LD   R30,X
	RJMP _0xCD
_0x3E:
	MOVW R30,R8
	__ADDW1MN _MemBuffer,256
	LD   R30,Z
_0xCD:
	OUT  0x2A,R30
; 0000 0095 if (FlagNeedReadNextData ==1 && FlagReadBufferInCard ==0){
	SBRS R2,6
	RJMP _0x41
	LDI  R26,0
	SBRC R2,4
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x42
_0x41:
	RJMP _0x40
_0x42:
; 0000 0096 FlagNeedReadNextData=0;
	CLT
	BLD  R2,6
; 0000 0097 if (FlagBufferToRecPlay ==0){
	SBRC R2,3
	RJMP _0x43
; 0000 0098 FlagBufferToInCard=1;
	SET
	BLD  R2,2
; 0000 0099 FlagReadBufferInCard=1; FlagReadBufferInCardOk=0;
	RJMP _0xCE
; 0000 009A }else{
_0x43:
; 0000 009B FlagBufferToInCard=0;
	CLT
	BLD  R2,2
; 0000 009C if (CounterLengRec >0){FlagReadBufferInCard=1; FlagReadBufferInCardOk=0;}
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRSH _0x45
_0xCE:
	SET
	BLD  R2,4
	CLT
	BLD  R2,5
; 0000 009D }
_0x45:
; 0000 009E }
; 0000 009F if (CursorMemBufferRecPlay == 255){
_0x40:
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	CP   R30,R8
	CPC  R31,R9
	BRNE _0x46
; 0000 00A0 FlagNeedReadNextData=1;
	SET
	BLD  R2,6
; 0000 00A1 CursorMemBufferRecPlay=0;
	CLR  R8
	CLR  R9
; 0000 00A2 if (FlagBufferToRecPlay ==0){FlagBufferToRecPlay=1;}else{FlagBufferToRecPlay=0;}
	SBRC R2,3
	RJMP _0x47
	RJMP _0xCF
_0x47:
	CLT
_0xCF:
	BLD  R2,3
; 0000 00A3 if (CounterLengRec <1){SystemRPstatus=7;}
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R10,R30
	CPC  R11,R31
	BRSH _0x49
	LDI  R30,LOW(7)
	MOV  R7,R30
; 0000 00A4 }else{CursorMemBufferRecPlay=CursorMemBufferRecPlay+1;}
_0x49:
	RJMP _0x4A
_0x46:
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
_0x4A:
; 0000 00A5 } // void QuantizatorPLAY()
	RET
;
;
;
;
;
;
;//       
;void ReadDataInFlashToBuffer(){
; 0000 00AD void ReadDataInFlashToBuffer(){
_ReadDataInFlashToBuffer:
; 0000 00AE int TempInt0;
; 0000 00AF if (CursorSDsectorToRead > MAXIMAL_SECTOR_NUMBER){CursorSDsectorToRead=0;}
	RCALL __SAVELOCR2
;	TempInt0 -> R16,R17
	LDS  R26,_CursorSDsectorToRead
	LDS  R27,_CursorSDsectorToRead+1
	LDS  R24,_CursorSDsectorToRead+2
	LDS  R25,_CursorSDsectorToRead+3
	__CPD2N 0x1D811A
	BRLO _0x4B
	LDI  R30,LOW(0)
	STS  _CursorSDsectorToRead,R30
	STS  _CursorSDsectorToRead+1,R30
	STS  _CursorSDsectorToRead+2,R30
	STS  _CursorSDsectorToRead+3,R30
; 0000 00B0 if (FlagBufferToInCard ==0){
_0x4B:
	SBRC R2,2
	RJMP _0x4C
; 0000 00B1 PORTD.2=1;
	SBI  0x12,2
; 0000 00B2 TempInt0=mmc_readsector_start256(CursorSDsectorToRead, MemBuffer);
	LDS  R30,_CursorSDsectorToRead
	LDS  R31,_CursorSDsectorToRead+1
	LDS  R22,_CursorSDsectorToRead+2
	LDS  R23,_CursorSDsectorToRead+3
	RCALL __PUTPARD1
	LDI  R30,LOW(_MemBuffer)
	LDI  R31,HIGH(_MemBuffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_readsector_start256
	MOVW R16,R30
; 0000 00B3 }else{
	RJMP _0x4F
_0x4C:
; 0000 00B4 PORTD.2=0;
	CBI  0x12,2
; 0000 00B5 TempInt0=mmc_readsector_next256(MemBuffer+256);
	__POINTW1MN _MemBuffer,256
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_readsector_next256
	MOVW R16,R30
; 0000 00B6 CursorSDsectorToRead=CursorSDsectorToRead+1;
	LDS  R30,_CursorSDsectorToRead
	LDS  R31,_CursorSDsectorToRead+1
	LDS  R22,_CursorSDsectorToRead+2
	LDS  R23,_CursorSDsectorToRead+3
	__ADDD1N 1
	STS  _CursorSDsectorToRead,R30
	STS  _CursorSDsectorToRead+1,R31
	STS  _CursorSDsectorToRead+2,R22
	STS  _CursorSDsectorToRead+3,R23
; 0000 00B7 if (CounterLengRec>0){CounterLengRec=CounterLengRec-1;}
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRSH _0x52
	MOVW R30,R10
	SBIW R30,1
	MOVW R10,R30
; 0000 00B8 }
_0x52:
_0x4F:
; 0000 00B9 if (TempInt0 ==0){
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x53
; 0000 00BA FlagReadBufferInCardOk=1;
	SET
	BLD  R2,5
; 0000 00BB CounterSboiSDcard=0;
	CLR  R6
; 0000 00BC }else{
	RJMP _0x54
_0x53:
; 0000 00BD PORTD.2=0; //  
	CBI  0x12,2
; 0000 00BE PORTD.3=0; //  
	CBI  0x12,3
; 0000 00BF if (CounterSboiSDcard <255){CounterSboiSDcard=CounterSboiSDcard+1;}
	LDI  R30,LOW(255)
	CP   R6,R30
	BRSH _0x59
	INC  R6
; 0000 00C0 }
_0x59:
_0x54:
; 0000 00C1 FlagReadBufferInCard=0;
	CLT
	BLD  R2,4
; 0000 00C2 } // void ReadDataInFlashToBuffer()
_0x2060001:
	RCALL __LOADLOCR2P
	RET
;
;
;
;
;
;
;
;
;
;//***************************************   **********************************************************//
;
;
;
;// Timer1 overflow interrupt service routine
;//  8000000/256 = 31250   
;interrupt [TIM1_OVF] void timer1_ovf_isr(void){
; 0000 00D2 interrupt [9] void timer1_ovf_isr(void){
_timer1_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00D3 bit TmpFlag0=0;
; 0000 00D4 
; 0000 00D5 TimerForQuantizator=TimerForQuantizator+1;
;	TmpFlag0 -> R15.0
	CLR  R15
	INC  R5
; 0000 00D6 if (TimerForQuantizator ==F_TIMER_DIV_CONST){
	LDI  R30,LOW(4)
	CP   R30,R5
	BRNE _0x5A
; 0000 00D7 TimerForQuantizator=0;
	CLR  R5
; 0000 00D8 if (SystemRPstatus ==1 || SystemRPstatus ==3){QuantizatorREC();}
	LDI  R30,LOW(1)
	CP   R30,R7
	BREQ _0x5C
	LDI  R30,LOW(3)
	CP   R30,R7
	BRNE _0x5B
_0x5C:
	RCALL _QuantizatorREC
; 0000 00D9 if (SystemRPstatus ==6){QuantizatorPLAY();}
_0x5B:
	LDI  R30,LOW(6)
	CP   R30,R7
	BRNE _0x5E
	RCALL _QuantizatorPLAY
; 0000 00DA }
_0x5E:
; 0000 00DB if (TimerForQuantizator ==1){
_0x5A:
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ PC+2
	RJMP _0x5F
; 0000 00DC 
; 0000 00DD TimerForAnalysisSignal=TimerForAnalysisSignal+1;
	INC  R4
; 0000 00DE if (TimerForAnalysisSignal ==42){ //  248   
	LDI  R30,LOW(42)
	CP   R30,R4
	BRNE _0x60
; 0000 00DF TimerForAnalysisSignal=0;
	CLR  R4
; 0000 00E0 if (PINB.7 == SQL_OPEN_LOG_SIGNAL){CounterSQLopen=0; if (CounterSQLclose <255){CounterSQLclose++;}}else{{CounterSQLclose=0; if (CounterSQLopen <255){CounterSQLopen++;}}}
	SBIC 0x16,7
	RJMP _0x61
	LDI  R30,LOW(0)
	STS  _CounterSQLopen,R30
	LDS  R26,_CounterSQLclose
	CPI  R26,LOW(0xFF)
	BRSH _0x62
	LDS  R30,_CounterSQLclose
	SUBI R30,-LOW(1)
	STS  _CounterSQLclose,R30
_0x62:
	RJMP _0x63
_0x61:
	LDI  R30,LOW(0)
	STS  _CounterSQLclose,R30
	LDS  R26,_CounterSQLopen
	CPI  R26,LOW(0xFF)
	BRSH _0x64
	LDS  R30,_CounterSQLopen
	SUBI R30,-LOW(1)
	STS  _CounterSQLopen,R30
_0x64:
_0x63:
; 0000 00E1 if (CounterSQLopen >10){FlagSQLopen=1;}
	LDS  R26,_CounterSQLopen
	CPI  R26,LOW(0xB)
	BRLO _0x65
	SET
	BLD  R2,7
; 0000 00E2 if (CounterSQLclose >5){FlagSQLopen=0;}
_0x65:
	LDS  R26,_CounterSQLclose
	CPI  R26,LOW(0x6)
	BRLO _0x66
	CLT
	BLD  R2,7
; 0000 00E3 } // if (TimerForAnalysisSignal ==42){ //  248   
_0x66:
; 0000 00E4 
; 0000 00E5 if (TimerForAnalysisSignal ==30){ //  248   
_0x60:
	LDI  R30,LOW(30)
	CP   R30,R4
	BREQ PC+2
	RJMP _0x67
; 0000 00E6 if (FlagSQLopen ==1){ //  else 
	SBRS R2,7
	RJMP _0x68
; 0000 00E7 // ST 
; 0000 00E8 
; 0000 00E9 if (SystemRPstatus ==0 && CounterSboiSDcard ==0 && !FlagMemBufferNeedSendToSDbuffer && !FlagWaitWriteSDbufferToFlash){
	LDI  R30,LOW(0)
	CP   R30,R7
	BRNE _0x6A
	CP   R30,R6
	BRNE _0x6A
	SBRC R2,0
	RJMP _0x6A
	SBRS R2,1
	RJMP _0x6B
_0x6A:
	RJMP _0x69
_0x6B:
; 0000 00EA PORTD.5=0; //  
	CBI  0x12,5
; 0000 00EB SystemRPstatus=1;
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 00EC CursorMemBufferRecPlay=0; //      
	CLR  R8
	CLR  R9
; 0000 00ED CounterLengRec=0;
	CLR  R10
	CLR  R11
; 0000 00EE CursorSDsectorToRead=CursorSDsectorToWrite;
	LDS  R30,_CursorSDsectorToWrite
	LDS  R31,_CursorSDsectorToWrite+1
	LDS  R22,_CursorSDsectorToWrite+2
	LDS  R23,_CursorSDsectorToWrite+3
	STS  _CursorSDsectorToRead,R30
	STS  _CursorSDsectorToRead+1,R31
	STS  _CursorSDsectorToRead+2,R22
	STS  _CursorSDsectorToRead+3,R23
; 0000 00EF }
; 0000 00F0 
; 0000 00F1 if (SystemRPstatus ==3){SystemRPstatus=1;}
_0x69:
	LDI  R30,LOW(3)
	CP   R30,R7
	BRNE _0x6E
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 00F2 
; 0000 00F3 if (SystemRPstatus ==1 && CounterLengRec > MAXIMAL_REC_SECTOR_LEN && !FlagMemBufferNeedSendToSDbuffer && !FlagWaitWriteSDbufferToFlash){
_0x6E:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x70
	LDI  R30,LOW(878)
	LDI  R31,HIGH(878)
	CP   R30,R10
	CPC  R31,R11
	BRSH _0x70
	SBRC R2,0
	RJMP _0x70
	SBRS R2,1
	RJMP _0x71
_0x70:
	RJMP _0x6F
_0x71:
; 0000 00F4 // ST     MAXIMAL_REC_SECTOR_LEN        
; 0000 00F5 SystemRPstatus=4;
	LDI  R30,LOW(4)
	MOV  R7,R30
; 0000 00F6 FlagBufferToInCard=0;
	CLT
	BLD  R2,2
; 0000 00F7 FlagReadBufferInCard=1;
	SET
	BLD  R2,4
; 0000 00F8 FlagReadBufferInCardOk=0;
	CLT
	BLD  R2,5
; 0000 00F9 // EN     MAXIMAL_REC_SECTOR_LEN        
; 0000 00FA // SystemRPstatus=2; //          
; 0000 00FB }
; 0000 00FC 
; 0000 00FD 
; 0000 00FE // EN 
; 0000 00FF }else{ // if (FlagSQLopen ==1){ //  else 
_0x6F:
	RJMP _0x72
_0x68:
; 0000 0100 // ST 
; 0000 0101 
; 0000 0102 if (SystemRPstatus ==1){CounterLengRecShellInterval=CounterLengRec; CounterShellInterval=0; SystemRPstatus=3;}
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x73
	MOVW R12,R10
	LDI  R30,LOW(0)
	STS  _CounterShellInterval,R30
	STS  _CounterShellInterval+1,R30
	LDI  R30,LOW(3)
	MOV  R7,R30
; 0000 0103 if (SystemRPstatus ==2){TmpFlag0=1;}
_0x73:
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0x74
	SET
	BLD  R15,0
; 0000 0104 if (SystemRPstatus ==3){
_0x74:
	LDI  R30,LOW(3)
	CP   R30,R7
	BRNE _0x75
; 0000 0105 CounterShellInterval=CounterShellInterval+1;
	LDS  R30,_CounterShellInterval
	LDS  R31,_CounterShellInterval+1
	ADIW R30,1
	STS  _CounterShellInterval,R30
	STS  _CounterShellInterval+1,R31
; 0000 0106 if (CounterShellInterval > SHELLED_INTERVAL_REC_PAST_SQL_CLOSE){
	LDS  R26,_CounterShellInterval
	LDS  R27,_CounterShellInterval+1
	CPI  R26,LOW(0x150)
	LDI  R30,HIGH(0x150)
	CPC  R27,R30
	BRLO _0x76
; 0000 0107 CounterLengRec=CounterLengRecShellInterval+PLAY_SECTOR_AFTER_SQL_CLOSE;
	MOVW R30,R12
	ADIW R30,2
	MOVW R10,R30
; 0000 0108 TmpFlag0=1;
	SET
	BLD  R15,0
; 0000 0109 }
; 0000 010A }
_0x76:
; 0000 010B 
; 0000 010C if (TmpFlag0 ==1){
_0x75:
	SBRS R15,0
	RJMP _0x77
; 0000 010D if (CounterLengRec > MINIMAL_REC_SECTOR_LEN_FOR_PLAY && CounterSboiSDcard ==0){
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R10
	CPC  R31,R11
	BRSH _0x79
	LDI  R30,LOW(0)
	CP   R30,R6
	BREQ _0x7A
_0x79:
	RJMP _0x78
_0x7A:
; 0000 010E SystemRPstatus=4;
	LDI  R30,LOW(4)
	MOV  R7,R30
; 0000 010F FlagReadBufferInCard=1;
	SET
	BLD  R2,4
; 0000 0110 FlagBufferToInCard=0;
	CLT
	BLD  R2,2
; 0000 0111 FlagReadBufferInCardOk=0;
	BLD  R2,5
; 0000 0112 }else{
	RJMP _0x7B
_0x78:
; 0000 0113 SystemRPstatus=0;
	CLR  R7
; 0000 0114 }
_0x7B:
; 0000 0115 }
; 0000 0116 
; 0000 0117 // EN 
; 0000 0118 } // else if (FlagSQLopen ==1){ //  else 
_0x77:
_0x72:
; 0000 0119 } // if (TimerForAnalysisSignal ==30){ //  248   
; 0000 011A 
; 0000 011B 
; 0000 011C 
; 0000 011D 
; 0000 011E if (TimerForAnalysisSignal ==35){ //  248   
_0x67:
	LDI  R30,LOW(35)
	CP   R30,R4
	BREQ PC+2
	RJMP _0x7C
; 0000 011F if (SystemRPstatus == 4 && FlagReadBufferInCardOk ==1){
	LDI  R30,LOW(4)
	CP   R30,R7
	BRNE _0x7E
	SBRC R2,5
	RJMP _0x7F
_0x7E:
	RJMP _0x7D
_0x7F:
; 0000 0120 CursorMemBufferRecPlay=0;
	CLR  R8
	CLR  R9
; 0000 0121 FlagNeedReadNextData=1;
	SET
	BLD  R2,6
; 0000 0122 FlagBufferToRecPlay=0; //     / : 0=_0; 1=_1
	CLT
	BLD  R2,3
; 0000 0123 SystemRPstatus=5;
	LDI  R30,LOW(5)
	MOV  R7,R30
; 0000 0124 CounterPTTonAndPause=0;
	LDI  R30,LOW(0)
	STS  _CounterPTTonAndPause,R30
	STS  _CounterPTTonAndPause+1,R30
; 0000 0125 PORTD.5=1; //  
	SBI  0x12,5
; 0000 0126 }
; 0000 0127 
; 0000 0128 if (SystemRPstatus == 5){
_0x7D:
	LDI  R30,LOW(5)
	CP   R30,R7
	BRNE _0x82
; 0000 0129 CounterPTTonAndPause=CounterPTTonAndPause+1;
	LDS  R30,_CounterPTTonAndPause
	LDS  R31,_CounterPTTonAndPause+1
	ADIW R30,1
	STS  _CounterPTTonAndPause,R30
	STS  _CounterPTTonAndPause+1,R31
; 0000 012A if (CounterPTTonAndPause > DELAY_BETWEEN_PTT_AND_PLAYBACK){
	LDS  R26,_CounterPTTonAndPause
	LDS  R27,_CounterPTTonAndPause+1
	CPI  R26,LOW(0x88)
	LDI  R30,HIGH(0x88)
	CPC  R27,R30
	BRLO _0x83
; 0000 012B SystemRPstatus=6; //  
	LDI  R30,LOW(6)
	MOV  R7,R30
; 0000 012C }
; 0000 012D }
_0x83:
; 0000 012E 
; 0000 012F 
; 0000 0130 if (SystemRPstatus ==7){
_0x82:
	LDI  R30,LOW(7)
	CP   R30,R7
	BRNE _0x84
; 0000 0131 OCR1AL=127;
	LDI  R30,LOW(127)
	OUT  0x2A,R30
; 0000 0132 CounterSQLopen=0;
	LDI  R30,LOW(0)
	STS  _CounterSQLopen,R30
; 0000 0133 CounterSQLclose=0;
	STS  _CounterSQLclose,R30
; 0000 0134 if (DELAY_PTT_ON_AFTER_ALL_PLAY >0){
; 0000 0135 SystemRPstatus=8;
	LDI  R30,LOW(8)
	MOV  R7,R30
; 0000 0136 CounterShellInterval=0;
	LDI  R30,LOW(0)
	STS  _CounterShellInterval,R30
	STS  _CounterShellInterval+1,R30
; 0000 0137 }else{
; 0000 0138 PORTD.5=0; //  
; 0000 0139 SystemRPstatus=0;
; 0000 013A }
; 0000 013B }
; 0000 013C 
; 0000 013D if (SystemRPstatus ==8){
_0x84:
	LDI  R30,LOW(8)
	CP   R30,R7
	BRNE _0x89
; 0000 013E CounterShellInterval=CounterShellInterval+1;
	LDS  R30,_CounterShellInterval
	LDS  R31,_CounterShellInterval+1
	ADIW R30,1
	STS  _CounterShellInterval,R30
	STS  _CounterShellInterval+1,R31
; 0000 013F if (CounterShellInterval > DELAY_PTT_ON_AFTER_ALL_PLAY){
	LDS  R26,_CounterShellInterval
	LDS  R27,_CounterShellInterval+1
	CPI  R26,LOW(0x65)
	LDI  R30,HIGH(0x65)
	CPC  R27,R30
	BRLO _0x8A
; 0000 0140 PORTD.5=0; //  
	CBI  0x12,5
; 0000 0141 SystemRPstatus=0;
	CLR  R7
; 0000 0142 }
; 0000 0143 }
_0x8A:
; 0000 0144 
; 0000 0145 
; 0000 0146 } // if (TimerForAnalysisSignal ==35){ //  248   
_0x89:
; 0000 0147 
; 0000 0148 
; 0000 0149 if (SystemRPstatus ==0){
_0x7C:
	TST  R7
	BRNE _0x8D
; 0000 014A CounterLengRec=CounterLengRec+1;
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
; 0000 014B if (CounterLengRec == 2500){CounterLengRec=0; SystemRPstatus=9;}
	LDI  R30,LOW(2500)
	LDI  R31,HIGH(2500)
	CP   R30,R10
	CPC  R31,R11
	BRNE _0x8E
	CLR  R10
	CLR  R11
	LDI  R30,LOW(9)
	MOV  R7,R30
; 0000 014C }
_0x8E:
; 0000 014D 
; 0000 014E 
; 0000 014F } // if (TimerForQuantizator ==1)
_0x8D:
; 0000 0150 
; 0000 0151 } // interrupt [TIM1_OVF] void timer1_ovf_isr(void)
_0x5F:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;
;
;
;
;
;
;
;
;void main(void){
; 0000 015C void main(void){
_main:
; 0000 015D // Declare your local variables here
; 0000 015E unsigned char CounterForBlinkSvetodiode2=0;
; 0000 015F bit FlagAddCounterForBlinkSvetodiode2=0;
; 0000 0160 
; 0000 0161 OSCCAL=255;
;	CounterForBlinkSvetodiode2 -> R17
;	FlagAddCounterForBlinkSvetodiode2 -> R15.0
	CLR  R15
	LDI  R17,0
	LDI  R30,LOW(255)
	OUT  0x31,R30
; 0000 0162 
; 0000 0163 // Input/Output Ports initialization
; 0000 0164 // Port B initialization
; 0000 0165 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In
; 0000 0166 // State7=T State6=T State5=T State4=T State3=T State2=T State1=0 State0=T
; 0000 0167 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0168 DDRB=0x02;
	LDI  R30,LOW(2)
	OUT  0x17,R30
; 0000 0169 
; 0000 016A // Port C initialization
; 0000 016B // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 016C // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 016D PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 016E DDRC=0x00;
	OUT  0x14,R30
; 0000 016F 
; 0000 0170 // Port D initialization
; 0000 0171 // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=In
; 0000 0172 // State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=T State0=T
; 0000 0173 PORTD=0x00;
	OUT  0x12,R30
; 0000 0174 DDRD=0x2C;
	LDI  R30,LOW(44)
	OUT  0x11,R30
; 0000 0175 
; 0000 0176 // Timer/Counter 0 initialization
; 0000 0177 // Clock source: System Clock
; 0000 0178 // Clock value: Timer 0 Stopped
; 0000 0179 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 017A TCNT0=0x00;
	OUT  0x32,R30
; 0000 017B 
; 0000 017C 
; 0000 017D // Timer/Counter 1 initialization
; 0000 017E // Clock source: System Clock
; 0000 017F // Clock value: 8000,000 kHz
; 0000 0180 // Mode: Fast PWM top=00FFh
; 0000 0181 // OC1A output: Non-Inv.
; 0000 0182 // OC1B output: Discon.
; 0000 0183 // Noise Canceler: Off
; 0000 0184 // Input Capture on Falling Edge
; 0000 0185 // Timer1 Overflow Interrupt: On
; 0000 0186 // Input Capture Interrupt: Off
; 0000 0187 // Compare A Match Interrupt: Off
; 0000 0188 // Compare B Match Interrupt: Off
; 0000 0189 TCCR1A=0x81;
	LDI  R30,LOW(129)
	OUT  0x2F,R30
; 0000 018A TCCR1B=0x09;
	LDI  R30,LOW(9)
	OUT  0x2E,R30
; 0000 018B TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 018C TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 018D ICR1H=0x00;
	OUT  0x27,R30
; 0000 018E ICR1L=0x00;
	OUT  0x26,R30
; 0000 018F OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0190 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0191 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0192 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0193 
; 0000 0194 // Timer/Counter 2 initialization
; 0000 0195 // Clock source: System Clock
; 0000 0196 // Clock value: Timer2 Stopped
; 0000 0197 // Mode: Normal top=FFh
; 0000 0198 // OC2 output: Disconnected
; 0000 0199 ASSR=0x00;
	OUT  0x22,R30
; 0000 019A TCCR2=0x00;
	OUT  0x25,R30
; 0000 019B TCNT2=0x00;
	OUT  0x24,R30
; 0000 019C OCR2=0x00;
	OUT  0x23,R30
; 0000 019D 
; 0000 019E // External Interrupt(s) initialization
; 0000 019F // INT0: Off
; 0000 01A0 // INT1: Off
; 0000 01A1 MCUCR=0x00;
	OUT  0x35,R30
; 0000 01A2 
; 0000 01A3 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01A4 TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 01A5 
; 0000 01A6 
; 0000 01A7 // Analog Comparator initialization
; 0000 01A8 // Analog Comparator: Off
; 0000 01A9 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01AA ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 01AB SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 01AC 
; 0000 01AD // ADC initialization
; 0000 01AE // ADC Clock frequency: 250,000 kHz
; 0000 01AF // ADC Voltage Reference: AVCC pin
; 0000 01B0 // Only the 8 most significant bits of
; 0000 01B1 // the AD conversion result are used
; 0000 01B2 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(96)
	OUT  0x7,R30
; 0000 01B3 ADCSRA=0b11100101; // + free running 
	LDI  R30,LOW(229)
	OUT  0x6,R30
; 0000 01B4 ADMUX=6 | (ADC_VREF_TYPE & 0xff); // 6  
	LDI  R30,LOW(102)
	OUT  0x7,R30
; 0000 01B5 ADCSRA|=0b01000000; //     
	SBI  0x6,6
; 0000 01B6 
; 0000 01B7 SystemRPstatus=9;
	LDI  R30,LOW(9)
	MOV  R7,R30
; 0000 01B8 
; 0000 01B9 // Global enable interrupts
; 0000 01BA #asm("sei")
	sei
; 0000 01BB PORTD.2=1; //  
	SBI  0x12,2
; 0000 01BC PORTD.3=1; //  
	SBI  0x12,3
; 0000 01BD OCR1AL=127;
	LDI  R30,LOW(127)
	OUT  0x2A,R30
; 0000 01BE delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01BF PORTD.3=0; //  
	CBI  0x12,3
; 0000 01C0 PORTD.5=1; //  
	SBI  0x12,5
; 0000 01C1 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01C2 PORTD.2=0; //  
	CBI  0x12,2
; 0000 01C3 PORTD.3=0; //  
	CBI  0x12,3
; 0000 01C4 PORTD.5=0; //  
	CBI  0x12,5
; 0000 01C5 delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01C6 
; 0000 01C7 while (mmc_init() !=0){delay_ms(100);}
_0x9D:
	RCALL _mmc_init
	CPI  R30,0
	BREQ _0x9F
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	RJMP _0x9D
_0x9F:
; 0000 01C8 if (mmc_readsector_start256(MAXIMAL_SECTOR_NUMBER, MemBuffer) ==0){
	__GETD1N 0x1D8119
	RCALL __PUTPARD1
	LDI  R30,LOW(_MemBuffer)
	LDI  R31,HIGH(_MemBuffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_readsector_start256
	SBIW R30,0
	BRNE _0xA0
; 0000 01C9 mmc_readsector_next256(MemBuffer);
	LDI  R30,LOW(_MemBuffer)
	LDI  R31,HIGH(_MemBuffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_readsector_next256
; 0000 01CA PORTD.3=1; //  
	SBI  0x12,3
; 0000 01CB PORTD.2=1; //  
	SBI  0x12,2
; 0000 01CC CounterSboiSDcard=0;
	CLR  R6
; 0000 01CD SystemRPstatus=0;
	CLR  R7
; 0000 01CE }
; 0000 01CF 
; 0000 01D0 
; 0000 01D1 while (1){
_0xA0:
_0xA5:
; 0000 01D2 
; 0000 01D3 if (FlagWaitWriteSDbufferToFlash){
	SBRS R2,1
	RJMP _0xA8
; 0000 01D4 if (spi_byte(0xFF)){FlagWaitWriteSDbufferToFlash=0; PORTD.2=0;} //    Flash      
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _spi_byte
	CPI  R30,0
	BREQ _0xA9
	CLT
	BLD  R2,1
	CBI  0x12,2
; 0000 01D5 }else{
_0xA9:
	RJMP _0xAC
_0xA8:
; 0000 01D6 if (FlagMemBufferNeedSendToSDbuffer){WriteDataToFlashBuffer(); PORTD.2=1;}else{if (FlagReadBufferInCard){ReadDataInFlashToBuffer();}}
	SBRS R2,0
	RJMP _0xAD
	RCALL _WriteDataToFlashBuffer
	SBI  0x12,2
	RJMP _0xB0
_0xAD:
	SBRC R2,4
	RCALL _ReadDataInFlashToBuffer
_0xB0:
; 0000 01D7 }
_0xAC:
; 0000 01D8 
; 0000 01D9 
; 0000 01DA 
; 0000 01DB 
; 0000 01DC if (SystemRPstatus ==0){
	TST  R7
	BRNE _0xB2
; 0000 01DD if (TimerForAnalysisSignal ==0 && FlagAddCounterForBlinkSvetodiode2){
	LDI  R30,LOW(0)
	CP   R30,R4
	BRNE _0xB4
	SBRC R15,0
	RJMP _0xB5
_0xB4:
	RJMP _0xB3
_0xB5:
; 0000 01DE FlagAddCounterForBlinkSvetodiode2=0;
	CLT
	BLD  R15,0
; 0000 01DF CounterForBlinkSvetodiode2=CounterForBlinkSvetodiode2+1;
	SUBI R17,-LOW(1)
; 0000 01E0 if (CounterForBlinkSvetodiode2 == 127){PORTD.2=1;}
	CPI  R17,127
	BRNE _0xB6
	SBI  0x12,2
; 0000 01E1 if (CounterForBlinkSvetodiode2 == 255){PORTD.2=0;}
_0xB6:
	CPI  R17,255
	BRNE _0xB9
	CBI  0x12,2
; 0000 01E2 }
_0xB9:
; 0000 01E3 if (TimerForAnalysisSignal ==1){FlagAddCounterForBlinkSvetodiode2=1;}
_0xB3:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0xBC
	SET
	BLD  R15,0
; 0000 01E4 }
_0xBC:
; 0000 01E5 
; 0000 01E6 
; 0000 01E7 if (SystemRPstatus ==9){
_0xB2:
	LDI  R30,LOW(9)
	CP   R30,R7
	BRNE _0xBD
; 0000 01E8 if (mmc_readsector_start256(MAXIMAL_SECTOR_NUMBER, MemBuffer) !=0){
	__GETD1N 0x1D8119
	RCALL __PUTPARD1
	LDI  R30,LOW(_MemBuffer)
	LDI  R31,HIGH(_MemBuffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_readsector_start256
	SBIW R30,0
	BREQ _0xBE
; 0000 01E9 CounterSboiSDcard=255;
	LDI  R30,LOW(255)
	MOV  R6,R30
; 0000 01EA }else{
	RJMP _0xBF
_0xBE:
; 0000 01EB mmc_readsector_next256(MemBuffer);
	LDI  R30,LOW(_MemBuffer)
	LDI  R31,HIGH(_MemBuffer)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _mmc_readsector_next256
; 0000 01EC SystemRPstatus=0; CounterSboiSDcard=0;
	CLR  R7
	CLR  R6
; 0000 01ED FlagWaitWriteSDbufferToFlash=0;
	CLT
	BLD  R2,1
; 0000 01EE FlagMemBufferNeedSendToSDbuffer=0;
	BLD  R2,0
; 0000 01EF }
_0xBF:
; 0000 01F0 }
; 0000 01F1 if (CounterSboiSDcard > 20){
_0xBD:
	LDI  R30,LOW(20)
	CP   R30,R6
	BRSH _0xC0
; 0000 01F2 SystemRPstatus=9;
	LDI  R30,LOW(9)
	MOV  R7,R30
; 0000 01F3 PORTD.2=0; //  
	CBI  0x12,2
; 0000 01F4 PORTD.3=0; //  
	CBI  0x12,3
; 0000 01F5 PORTD.5=0; //  
	CBI  0x12,5
; 0000 01F6 while (mmc_init() !=0){delay_ms(200);}
_0xC7:
	RCALL _mmc_init
	CPI  R30,0
	BREQ _0xC9
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	RJMP _0xC7
_0xC9:
; 0000 01F7 PORTD.2=1; //  
	SBI  0x12,2
; 0000 01F8 FlagWaitWriteSDbufferToFlash=0;
	CLT
	BLD  R2,1
; 0000 01F9 FlagMemBufferNeedSendToSDbuffer=0;
	BLD  R2,0
; 0000 01FA FlagReadBufferInCard=0; //      ? 1=
	BLD  R2,4
; 0000 01FB } // if (CounterSboiSDcard > 20)
; 0000 01FC 
; 0000 01FD 
; 0000 01FE 
; 0000 01FF };
_0xC0:
	RJMP _0xA5
; 0000 0200 }
_0xCC:
	RJMP _0xCC
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_MemBuffer:
	.BYTE 0x264
_CursorSDsectorToWrite:
	.BYTE 0x4
_CursorSDsectorToRead:
	.BYTE 0x4
_CounterShellInterval:
	.BYTE 0x2
_CounterSQLopen:
	.BYTE 0x1
_CounterSQLclose:
	.BYTE 0x1
_CounterPTTonAndPause:
	.BYTE 0x2

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
